#ifndef  _RTC_H
#define  _RTC_H 1
#include <avr/io.h>
#define BYTE  unsigned char
#define TRUE                 (BYTE)1
#define FALSE                (BYTE)0
#define NOP()      asm("nop")

#define SetBit(ADRESS,B)         ((ADRESS) |=  (1<<(B)))
#define ClearBit(ADRESS,B)       ((ADRESS) &= ~(1<<(B)))
#define CheckBit(ADRESS,B)       (BYTE)((ADRESS) &   (1<<(B)))
#define ToggleBit(ADDRESS,BIT)   ((ADDRESS) ^= (1<<BIT))

volatile struct zeit {
		BYTE sec;
        BYTE min;                    
        BYTE hrs;
        BYTE day;
        BYTE month;
        BYTE year;
        BYTE dow;                  // day of week Montag = 1
       } uhr;

//=================================================
// je nachdem, an welchem Port DS1302 haengt,
// muessen diese Werte angepasst werden
#define RTC_CLK             1    
#define RTC_DATA            2
#define RTC_RES             5

#define RTC_CLK_LOW()             ClearBit(PORTA,RTC_CLK)
#define RTC_CLK_HIGH()            SetBit(PORTA,RTC_CLK)
#define RTC_DATA_LOW()            ClearBit(PORTA,RTC_DATA)
#define RTC_DATA_HIGH()           SetBit(PORTA,RTC_DATA)
#define CHECK_RTC_DATA()          CheckBit(PINA,RTC_DATA)
#define RTC_RESET_LOW()           ClearBit(PORTA,RTC_RES)
#define RTC_RESET_HIGH()          SetBit(PORTA,RTC_RES)
#define RTC_DATA_LINE_IS_OUTPUT() SetBit(DDRA,   RTC_DATA)
#define RTC_DATA_LINE_IS_INPUT()  ClearBit(DDRA, RTC_DATA)
// Ende der Anpassung
//=================================================

#define RTC_RAM   1
#define RTC_CLOCK 0

#define RTC_SEC   0
#define RTC_MIN   1
#define RTC_HRS   2
#define RTC_DAY   3
#define RTC_MONTH 4
#define RTC_DOW   5					// day of week (1 = Mon)
#define RTC_YEAR  6


#define CONTROL_REGISTER 0x8E 
#define PROTECT   0x80        
#define UNPROTECT 0x00        

BYTE BCDtoBin(BYTE val);
void RTC_Init(void );
void RTC_SetTime( void );
void RTC_GetTime( void );
void RTC_Unprotect( void ); 
void RTC_Protect( void ); 
BYTE RTC_Ctrl( void );
#endif

